try/finally with bash shellGetting “ensure” / “finally” functionality in a shell command (not script)?How do I set permissions recursively on a dir (with ACL enabled)?How can avoid these spurious characters in my bash prompt?Editing lines in a file using a bash script?Parse XML file to copy the content into another file at a particular spot in the file?How to make bash built-in “read” ignore commented or empty lines?Getting “ensure” / “finally” functionality in a shell command (not script)?How to create a loop with five (5) input variables?sed - if condition met, use next pattern

try/finally with bash shell

How can I shift my job responsibilities back to programming?

Should you play baroque pieces a semitone lower?

Why did Gandalf use a sword against the Balrog?

Te-form and かつ and も?

Can the Action some concentration spells grant be used in Attacks of Opportunity with the War Caster feat?

During the Space Shuttle Columbia Disaster of 2003, Why Did The Flight Director Say, "Lock the doors."?

Can the ground attached to neutral fool a receptacle tester?

How is this kind of structure made?

What happen to those who died but not from the snap?

Understanding the point of a kölsche Witz

Withdrew when Jimmy met up with Heath

Why is transplanting a specific intact brain impossible if it is generally possible?

Who are these characters/superheroes in the posters from Chris's room in Family Guy?

Y2K... in 2019?

Tikzpicture - finish drawing a curved line for a cake slice

elisp regular expression build problem

Why does Intel's Haswell chip allow FP multiplication to be twice as fast as addition?

Infeasibility in mathematical optimization models

A simple stop watch which I want to extend

What are the uses and limitations of Persuasion, Insight, and Deception against other PCs?

Help evaluating integral (anything simple that I am missing?)

(11 of 11: Meta) What is Pyramid Cult's All-Time Favorite?

What gave Harry Potter the idea of writing in Tom Riddle's diary?



try/finally with bash shell


Getting “ensure” / “finally” functionality in a shell command (not script)?How do I set permissions recursively on a dir (with ACL enabled)?How can avoid these spurious characters in my bash prompt?Editing lines in a file using a bash script?Parse XML file to copy the content into another file at a particular spot in the file?How to make bash built-in “read” ignore commented or empty lines?Getting “ensure” / “finally” functionality in a shell command (not script)?How to create a loop with five (5) input variables?sed - if condition met, use next pattern






.everyoneloves__top-leaderboard:empty,.everyoneloves__mid-leaderboard:empty,.everyoneloves__bot-mid-leaderboard:empty margin-bottom:0;








1















I have these three lines:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"


I need to make sure the last line always executes..I could do this:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
(
set +e
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
)


or maybe like this:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion && rm -f "$bunion_uds_file" || rm -f "$bunion_uds_file"


I assume creating the subshell and using set +e is slightly less performant etc.










share|improve this question


























  • The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by SIGKILL. Then the next instance will fail with EADDRINUSE when trying to bind to it.

    – mosvy
    7 hours ago











  • Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?

    – muru
    3 hours ago

















1















I have these three lines:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"


I need to make sure the last line always executes..I could do this:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
(
set +e
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
)


or maybe like this:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion && rm -f "$bunion_uds_file" || rm -f "$bunion_uds_file"


I assume creating the subshell and using set +e is slightly less performant etc.










share|improve this question


























  • The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by SIGKILL. Then the next instance will fail with EADDRINUSE when trying to bind to it.

    – mosvy
    7 hours ago











  • Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?

    – muru
    3 hours ago













1












1








1








I have these three lines:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"


I need to make sure the last line always executes..I could do this:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
(
set +e
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
)


or maybe like this:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion && rm -f "$bunion_uds_file" || rm -f "$bunion_uds_file"


I assume creating the subshell and using set +e is slightly less performant etc.










share|improve this question
















I have these three lines:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"


I need to make sure the last line always executes..I could do this:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
(
set +e
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
)


or maybe like this:



 export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion && rm -f "$bunion_uds_file" || rm -f "$bunion_uds_file"


I assume creating the subshell and using set +e is slightly less performant etc.







bash shell exit-status






share|improve this question















share|improve this question













share|improve this question




share|improve this question








edited 7 hours ago









Kusalananda

159k18 gold badges314 silver badges500 bronze badges




159k18 gold badges314 silver badges500 bronze badges










asked 8 hours ago









Alexander MillsAlexander Mills

2,4872 gold badges22 silver badges67 bronze badges




2,4872 gold badges22 silver badges67 bronze badges















  • The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by SIGKILL. Then the next instance will fail with EADDRINUSE when trying to bind to it.

    – mosvy
    7 hours ago











  • Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?

    – muru
    3 hours ago

















  • The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by SIGKILL. Then the next instance will fail with EADDRINUSE when trying to bind to it.

    – mosvy
    7 hours ago











  • Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?

    – muru
    3 hours ago
















The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by SIGKILL. Then the next instance will fail with EADDRINUSE when trying to bind to it.

– mosvy
7 hours ago





The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by SIGKILL. Then the next instance will fail with EADDRINUSE when trying to bind to it.

– mosvy
7 hours ago













Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?

– muru
3 hours ago





Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?

– muru
3 hours ago










1 Answer
1






active

oldest

votes


















3














You could set a trap:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT

"$cmd" "$@" | bunion


This would make the rm -f command run whenever the shell session terminates, except for when terminating by the KILL signal.



As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1

"$cmd" "$@" | bunion





share|improve this answer



























  • I like to put the trap code in a function: cleanup() rm -f $thefile; and then trap cleanup EXIT -- I think it's cleaner, and it solves any quoting problems.

    – glenn jackman
    7 hours ago












  • @glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.

    – Kusalananda
    7 hours ago












  • Yes, bash (but not dash or zsh) will also call the EXIT trap when being killed by a SIGINT or SIGTERM, but I don't know how wise it is to rely on that.

    – mosvy
    7 hours ago













Your Answer








StackExchange.ready(function()
var channelOptions =
tags: "".split(" "),
id: "106"
;
initTagRenderer("".split(" "), "".split(" "), channelOptions);

StackExchange.using("externalEditor", function()
// Have to fire editor after snippets, if snippets enabled
if (StackExchange.settings.snippets.snippetsEnabled)
StackExchange.using("snippets", function()
createEditor();
);

else
createEditor();

);

function createEditor()
StackExchange.prepareEditor(
heartbeatType: 'answer',
autoActivateHeartbeat: false,
convertImagesToLinks: false,
noModals: true,
showLowRepImageUploadWarning: true,
reputationToPostImages: null,
bindNavPrevention: true,
postfix: "",
imageUploader:
brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
allowUrls: true
,
onDemand: true,
discardSelector: ".discard-answer"
,immediatelyShowMarkdownHelp:true
);



);













draft saved

draft discarded


















StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f535057%2ftry-finally-with-bash-shell%23new-answer', 'question_page');

);

Post as a guest















Required, but never shown

























1 Answer
1






active

oldest

votes








1 Answer
1






active

oldest

votes









active

oldest

votes






active

oldest

votes









3














You could set a trap:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT

"$cmd" "$@" | bunion


This would make the rm -f command run whenever the shell session terminates, except for when terminating by the KILL signal.



As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1

"$cmd" "$@" | bunion





share|improve this answer



























  • I like to put the trap code in a function: cleanup() rm -f $thefile; and then trap cleanup EXIT -- I think it's cleaner, and it solves any quoting problems.

    – glenn jackman
    7 hours ago












  • @glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.

    – Kusalananda
    7 hours ago












  • Yes, bash (but not dash or zsh) will also call the EXIT trap when being killed by a SIGINT or SIGTERM, but I don't know how wise it is to rely on that.

    – mosvy
    7 hours ago















3














You could set a trap:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT

"$cmd" "$@" | bunion


This would make the rm -f command run whenever the shell session terminates, except for when terminating by the KILL signal.



As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1

"$cmd" "$@" | bunion





share|improve this answer



























  • I like to put the trap code in a function: cleanup() rm -f $thefile; and then trap cleanup EXIT -- I think it's cleaner, and it solves any quoting problems.

    – glenn jackman
    7 hours ago












  • @glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.

    – Kusalananda
    7 hours ago












  • Yes, bash (but not dash or zsh) will also call the EXIT trap when being killed by a SIGINT or SIGTERM, but I don't know how wise it is to rely on that.

    – mosvy
    7 hours ago













3












3








3







You could set a trap:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT

"$cmd" "$@" | bunion


This would make the rm -f command run whenever the shell session terminates, except for when terminating by the KILL signal.



As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1

"$cmd" "$@" | bunion





share|improve this answer















You could set a trap:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT

"$cmd" "$@" | bunion


This would make the rm -f command run whenever the shell session terminates, except for when terminating by the KILL signal.



As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:



#!/bin/bash

export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1

"$cmd" "$@" | bunion






share|improve this answer














share|improve this answer



share|improve this answer








edited 7 hours ago

























answered 8 hours ago









KusalanandaKusalananda

159k18 gold badges314 silver badges500 bronze badges




159k18 gold badges314 silver badges500 bronze badges















  • I like to put the trap code in a function: cleanup() rm -f $thefile; and then trap cleanup EXIT -- I think it's cleaner, and it solves any quoting problems.

    – glenn jackman
    7 hours ago












  • @glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.

    – Kusalananda
    7 hours ago












  • Yes, bash (but not dash or zsh) will also call the EXIT trap when being killed by a SIGINT or SIGTERM, but I don't know how wise it is to rely on that.

    – mosvy
    7 hours ago

















  • I like to put the trap code in a function: cleanup() rm -f $thefile; and then trap cleanup EXIT -- I think it's cleaner, and it solves any quoting problems.

    – glenn jackman
    7 hours ago












  • @glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.

    – Kusalananda
    7 hours ago












  • Yes, bash (but not dash or zsh) will also call the EXIT trap when being killed by a SIGINT or SIGTERM, but I don't know how wise it is to rely on that.

    – mosvy
    7 hours ago
















I like to put the trap code in a function: cleanup() rm -f $thefile; and then trap cleanup EXIT -- I think it's cleaner, and it solves any quoting problems.

– glenn jackman
7 hours ago






I like to put the trap code in a function: cleanup() rm -f $thefile; and then trap cleanup EXIT -- I think it's cleaner, and it solves any quoting problems.

– glenn jackman
7 hours ago














@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.

– Kusalananda
7 hours ago






@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.

– Kusalananda
7 hours ago














Yes, bash (but not dash or zsh) will also call the EXIT trap when being killed by a SIGINT or SIGTERM, but I don't know how wise it is to rely on that.

– mosvy
7 hours ago





Yes, bash (but not dash or zsh) will also call the EXIT trap when being killed by a SIGINT or SIGTERM, but I don't know how wise it is to rely on that.

– mosvy
7 hours ago

















draft saved

draft discarded
















































Thanks for contributing an answer to Unix & Linux Stack Exchange!


  • Please be sure to answer the question. Provide details and share your research!

But avoid


  • Asking for help, clarification, or responding to other answers.

  • Making statements based on opinion; back them up with references or personal experience.

To learn more, see our tips on writing great answers.




draft saved


draft discarded














StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f535057%2ftry-finally-with-bash-shell%23new-answer', 'question_page');

);

Post as a guest















Required, but never shown





















































Required, but never shown














Required, but never shown












Required, but never shown







Required, but never shown

































Required, but never shown














Required, but never shown












Required, but never shown







Required, but never shown







Popular posts from this blog

Invision Community Contents History See also References External links Navigation menuProprietaryinvisioncommunity.comIPS Community ForumsIPS Community Forumsthis blog entry"License Changes, IP.Board 3.4, and the Future""Interview -- Matt Mecham of Ibforums""CEO Invision Power Board, Matt Mecham Is a Liar, Thief!"IPB License Explanation 1.3, 1.3.1, 2.0, and 2.1ArchivedSecurity Fixes, Updates And Enhancements For IPB 1.3.1Archived"New Demo Accounts - Invision Power Services"the original"New Default Skin"the original"Invision Power Board 3.0.0 and Applications Released"the original"Archived copy"the original"Perpetual licenses being done away with""Release Notes - Invision Power Services""Introducing: IPS Community Suite 4!"Invision Community Release Notes

Canceling a color specificationRandomly assigning color to Graphics3D objects?Default color for Filling in Mathematica 9Coloring specific elements of sets with a prime modified order in an array plotHow to pick a color differing significantly from the colors already in a given color list?Detection of the text colorColor numbers based on their valueCan color schemes for use with ColorData include opacity specification?My dynamic color schemes

Ласкавець круглолистий Зміст Опис | Поширення | Галерея | Примітки | Посилання | Навігаційне меню58171138361-22960890446Bupleurum rotundifoliumEuro+Med PlantbasePlants of the World Online — Kew ScienceGermplasm Resources Information Network (GRIN)Ласкавецькн. VI : Літери Ком — Левиправивши або дописавши її